<?php

namespace App\Services;

use App\Entities\Customer\ClientEntity;
use App\Entities\Customer\ServiceEntity;
use App\Entities\Equipment\ServerPartEntity;
use App\Entities\PaymentEntity;
use App\Helpers\PaymentHelper;
use App\Interfaces\Customer\ServiceInterface;
use App\Interfaces\Equipment\ServerPartInterface;
use App\Models\PaymentModel;
use App\Services\CommonService;
use App\Services\Customer\AccountService;
use App\Services\Customer\ServiceService;
use App\Services\Equipment\ServerPartService;

class PaymentService extends CommonService implements ServiceInterface, ServerPartInterface
{
    private ?ServiceService $_serviceService = null;
    private ?ServerPartService $_serverPartService = null;
    private ?AccountService $_accountService = null;
    public function __construct()
    {
        parent::__construct(new PaymentModel(), new PaymentHelper());
        $this->addClassName('Payment');
    }
    final public function getFormFields(): array
    {
        return [
            "serviceinfo_uid",
            "title",
            "amount",
            "billing",
            "billing_at",
            "content"
        ];
    }
    final public function getFormFilters(): array
    {
        return  [
            'clientinfo_uid',
            "serviceinfo_uid",
            'billing',
            'pay',
            'status',
            'user_uid',
        ];
    }
    final public function getIndexFields(): array
    {
        return [
            'clientinfo_uid',
            "serviceinfo_uid",
            'billing',
            'title',
            'amount',
            'billing_at',
            'pay',
            'status',
            'updated_at',
            'countdown',
            'user_uid',
        ];
    }
    final public function getBatchjobFields(): array
    {
        return [];
    }
    final public function getBatchjobButtons(): array
    {
        return [
            'batchjob' => '결제 처리',
            'invoice' => '청구서 발행',
        ];
    }
    final public function getServiceService(): ServiceService
    {
        if ($this->_serviceService === null) {
            $this->_serviceService = new ServiceService();
        }
        return $this->_serviceService;
    }
    final public function getServerPartService(): ServerPartService
    {
        if (!$this->_serverPartService) {
            $this->_serverPartService = new ServerPartService();
        }
        return $this->_serverPartService;
    }
    final public function getAccountService(): AccountService
    {
        if (!$this->_accountService) {
            $this->_accountService = new AccountService();
        }
        return $this->_accountService;
    }
    //총 미납건수, 금액
    final public function getUnPaids(string $group, array $where = []): array
    {
        $builder = $this->getModel()->groupBy($group)
            ->select("{$group},COUNT(uid) as cnt, SUM(amount) as amount")
            ->where(['status' => STATUS['UNPAID']])
            ->where($where)
            ->builder();
        // echo $builder->getCompiledSelect(false); //초기화 없이 SQL만 보고 싶을 때: getCompiledSelect(false) ← 꼭 false!            
        $unPaids = [];
        foreach ($builder->get()->getResult() as $row) {
            $unPaids[$row->$group] = ['cnt' => $row->cnt, 'amount' => $row->amount];
        }
        return $unPaids;
    }
    //서비스정보 설정
    final public function setService(string $action, ServiceEntity $serviceEntity, array $serviceFormDatas): ServiceEntity
    {
        switch ($action) {
            case 'create': //서비스 가격 추가용
                $formDatas = [];
                $formDatas['clientinfo_uid'] = $serviceEntity->getClientInfoUID();
                $formDatas['serviceinfo_uid'] = $serviceEntity->getPK();
                $formDatas['serverinfo_uid'] = $serviceEntity->getServerInfoUID();
                $formDatas['title']           = sprintf(
                    "[%s/%s] %s 서비스비용",
                    $serviceEntity->getServerEntity()->getCode(),
                    $serviceEntity->getServerEntity()->getIP(),
                    date("Y년 n월", strtotime($serviceEntity->getBillingAt()))
                );
                $formDatas['amount'] = $serviceEntity->getAmount();
                $formDatas['billing'] = PAYMENT['BILLING']['MONTH'];
                $formDatas['billing_at'] = $serviceEntity->getBillingAt();
                $entity = parent::create($formDatas);
                break;
            case 'modify': //서비스 가격 수정용
                if ($serviceEntity->getPaymentUID()  === null) {
                    throw new \Exception(__METHOD__ . "에서 {$action}오류발생:서비스정보에 결제정보가 정의되지 않았습니다.");
                }
                $entity = $this->getEntity($serviceEntity->getPaymentUID());
                if (!$entity instanceof PaymentEntity) {
                    throw new \Exception(__METHOD__ . "에서 {$action}오류발생:결제정보를 찾을수 없습니다.");
                }
                if ($entity->getStatus() === STATUS['PAID']) {
                    throw new \Exception(__METHOD__ . "에서 {$action}오류발생:결제완료된 서비스는 수정할수 없습니다.");
                }
                $formDatas                    = [];
                $formDatas['clientinfo_uid']  = $serviceEntity->getClientInfoUID();
                $formDatas['serviceinfo_uid'] = $serviceEntity->getPK();
                $formDatas['serverinfo_uid']  = $serviceEntity->getServerInfoUID();
                $formDatas['title']           = sprintf(
                    "[%s/%s] %s 서비스비용",
                    $serviceEntity->getServerEntity()->getCode(),
                    $serviceEntity->getServerEntity()->getIP(),
                    date("Y년 n월", strtotime($serviceEntity->getBillingAt()))
                );
                $formDatas['amount']          = $serviceEntity->getAmount();
                $formDatas['billing']         = PAYMENT['BILLING']['MONTH'];
                $formDatas['billing_at']      = $serviceEntity->getBillingAt();
                $entity                       = parent::modify($entity, $formDatas);
                break;
            case 'delete':
                if ($serviceEntity->getPaymentUID()  === null) {
                    throw new \Exception(__METHOD__ . "에서 {$action}오류발생:서비스정보에 결제정보가 정의되지 않았습니다.");
                }
                $entity = $this->getEntity($serviceEntity->getPaymentUID());
                if (!$entity instanceof PaymentEntity) {
                    throw new \Exception(__METHOD__ . "에서 {$action}오류발생:결제정보를 찾을수 없습니다.");
                }
                if ($entity->getStatus() === STATUS['PAID']) {
                    throw new \Exception(__METHOD__ . "에서 {$action}오류발생:결제완료된 서비스는 수정할수 없습니다.");
                }
                $entity = parent::delete($entity);
                break;
            default:
                throw new \Exception(__METHOD__ . "에서 오류발생:{$action}은 정의되지 않은 작업입니다.");
                // break;
        }
        if (!$entity instanceof PaymentEntity) {
            throw new \Exception(__METHOD__ . "에서 {$action}->setPaymentEntity오류발생:결제정보를 찾을수 없습니다.");
        }
        return $serviceEntity->setPaymentEntity($entity);
    }
    final public function setServerPart(string $action, ServerPartEntity $serverPartEntity, array $servicePartFormDatas): ServerPartEntity
    {
        switch ($action) {
            case 'create': //일회성 서비스 생성용
                $formDatas                    = [];
                $formDatas['clientinfo_uid']     = $serverPartEntity->getClientInfoUID();
                $formDatas['serviceinfo_uid']    = $serverPartEntity->getServiceInfoUID();
                $formDatas['serverinfo_uid']     = $serverPartEntity->getServerInfoUID(); //서버연결정보 수정시에 필요함
                //타이틀은 기타의 경우 직접작성한 제목을 등록하고 아닌경우는 Part의 Title을 사용한다.
                $formDatas['title']              = $serverPartEntity->getPartEntity()->getTitle();
                $formDatas['amount']             = $serverPartEntity->getTotalAmount(); //단가*cnt
                $formDatas['billing']            = $serverPartEntity->getBilling();
                //당일결체일로 설정
                $formDatas['billing_at'] = date("Y-m-d");
                $entity = parent::create($formDatas);
                break;
            case 'modify': //일회성 서비스 수정용
                if ($serverPartEntity->getPaymentUID()  === null) {
                    throw new \Exception(__METHOD__ . "에서 {$action}오류발생:일회성서비스정보에 결제정보가 정의되지 않았습니다.");
                }
                $entity = $this->getEntity($serverPartEntity->getPaymentUID());
                if (!$entity instanceof PaymentEntity) {
                    throw new \Exception(__METHOD__ . "에서 {$action}오류발생:결제정보를 찾을수 없습니다.");
                }
                if ($entity->getStatus() === STATUS['PAID']) {
                    throw new \Exception(__METHOD__ . "에서 {$action}오류발생:결제완료된 서비스는 수정할수 없습니다.");
                }
                $formDatas                    = [];
                $formDatas['clientinfo_uid']     = $serverPartEntity->getClientInfoUID();
                $formDatas['serviceinfo_uid']    = $serverPartEntity->getServiceInfoUID();
                $formDatas['serverinfo_uid']     = $serverPartEntity->getServerInfoUID(); //서버연결정보 수정시에 필요함
                //타이틀은 기타의 경우 직접작성한 제목을 등록하고 아닌경우는 Part의 Title을 사용한다.
                $formDatas['title']              = $serverPartEntity->getPartEntity()->getTitle();
                $formDatas['amount']             = $serverPartEntity->getTotalAmount(); //단가*cnt
                $formDatas['billing']            = $serverPartEntity->getBilling();
                $entity = parent::modify($entity, $formDatas);
                break;
            case 'delete':
                if ($serverPartEntity->getPaymentUID()  === null) {
                    throw new \Exception(__METHOD__ . "에서 {$action}오류발생:일회성서비스정보에 결제정보가 정의되지 않았습니다.");
                }
                $entity = $this->getEntity($serverPartEntity->getPaymentUID());
                if (!$entity instanceof PaymentEntity) {
                    throw new \Exception(__METHOD__ . "에서 {$action}오류발생:결제정보를 찾을수 없습니다.");
                }
                if ($entity->getStatus() === STATUS['PAID']) {
                    throw new \Exception(__METHOD__ . "에서 {$action}오류발생:결제완료된 서비스는 수정할수 없습니다.");
                }
                $entity = parent::delete($entity);
                break;
            default:
                throw new \Exception(__METHOD__ . "에서 오류발생:{$action}은 정의되지 않은 작업입니다.");
                // break;
        }
        if (!$entity instanceof PaymentEntity) {
            throw new \Exception(__METHOD__ . "에서 {$action}->setPaymentEntity오류발생:결제정보를 찾을수 없습니다.");
        }
        return $serverPartEntity->setPaymentEntity($entity);
    }
    //Invoice 관련
    public function getInvoiceData(ClientEntity $clientEntity, ServiceEntity $serviceEntity, PaymentEntity $entity, array $rows): array
    {
        if (!array_key_exists($clientEntity->getPK(), $rows)) {
            $rows[$clientEntity->getPK()] = [
                'name'         => $clientEntity->getName(),
                'total_amount' => 0,
                'services'     => [],
            ];
        }
        if (!array_key_exists($serviceEntity->getPK(), $rows[$clientEntity->getPK()]['services'])) {
            $rows[$clientEntity->getPK()]['services'][$serviceEntity->getPK()] = [
                'ip'       => $serviceEntity->getServerEntity()->getIP(),
                'billing_at' => $serviceEntity->getBillingAt(),
                'items'      => [],
            ];
        }
        //entities에 총 결제금액 설정
        $rows[$clientEntity->getPK()]['services'][$serviceEntity->getPK()]['items'][] = ['title' => $entity->getTitle(), 'amount' => $entity->getAmount()];
        $rows[$clientEntity->getPK()]['total_amount'] += $entity->getAmount();
        return $rows;
    }
    //기본 기능부분
    //FieldForm관련용
    final public function getFormOption(string $field, array $options = []): array
    {
        switch ($field) {
            case 'serviceinfo_uid':
                $options = $this->getServiceService()->getEntities();
                break;
            default:
                $options = parent::getFormOption($field, $options);
                break;
        }
        return $options;
    }
    //Action 기능
    //일회성등록(일회성은 예치금에 관련된것만 등록한다.)
    public function create(array $formDatas): PaymentEntity
    {
        if (!array_key_exists('serviceinfo_uid', $formDatas)) {
            throw new \Exception("서비스정보가 없습니다.");
        }
        //서비스정보 가져오기
        $serviceEntity = $this->getServiceService()->getEntity($formDatas['serviceinfo_uid']);
        if (!$serviceEntity instanceof ServiceEntity) {
            throw new \Exception(__METHOD__ . "에서 오류발생: 서비스정보[{$formDatas['serviceinfo_uid']}]를 찾을수 없습니다.");
        }
        //결제 완료 처리 후 추가정보 처리
        $formDatas['clientinfo_uid'] = $serviceEntity->getClientInfoUID();
        return parent::create($formDatas);
    }
    //일괄결제처리(결제는 무조건 예치금으로만 처리)
    public function batchjob(mixed $entity, array $formDatas): mixed
    {
        //결제 완료 처리 후 추가정보 처리
        $formDatas['status'] = STATUS['PAID'];
        $entity = parent::batchjob($entity, $formDatas);
        //예치금처리
        return $this->getAccountService()->setPayment('create', $entity, []);
    }
    //List 검색용
    //OrderBy 처리
    final public function setOrderBy(mixed $field = null, mixed $value = null): void
    {
        $this->getModel()->orderBy('billing_at ASC');
        parent::setOrderBy($field, $value);
    }
}
